#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ScanPattern {
    #[serde(rename = "ROTATING")]
    Rotating,
    #[serde(rename = "SOLID_STATE")]
    SolidState,
    #[serde(rename = "FLASH")]
    Flash,
    #[serde(rename = "MECHANICAL")]
    Mechanical,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ScanPattern {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ScanPattern::Rotating => "ROTATING",
            ScanPattern::SolidState => "SOLID_STATE",
            ScanPattern::Flash => "FLASH",
            ScanPattern::Mechanical => "MECHANICAL",
            ScanPattern::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ScanPattern {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ScanPattern {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ScanPattern {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<ScanPattern, conjure_object::plain::ParseEnumError> {
        match v {
            "ROTATING" => Ok(ScanPattern::Rotating),
            "SOLID_STATE" => Ok(ScanPattern::SolidState),
            "FLASH" => Ok(ScanPattern::Flash),
            "MECHANICAL" => Ok(ScanPattern::Mechanical),
            v => v.parse().map(|v| ScanPattern::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for ScanPattern {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<ScanPattern, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the ScanPattern enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
